 #define Version "02-01-2016"
 #define Source "18F45K22_DS18B20_OneWire.c"
//  MCU:             PIC18F45k22
//  Dev.Board:       MikroE Ready For PIC avec PIC18F45K22
//  Docu:

 #define Project "18F45K22_DS18B20_OneWire_2016.mcppi"
 #define With_TMR1
 #define With LCD2119
 #define OSCILLATEUR_INTERNE
 #define  TEST_FOSC
 #define With_DS18B20
 #define With_UART1

 #define PROCESSOR 18F45k22
 #define POWER_SUPPLY_5V

 #ifdef OSCILLATEUR_INTERNE
 #define FOSC 8.0  // MHz
 #define BAUD 19200  // UART1
 //P18F45K22_Q8Mhz_No_PLL.cfgsch
 #else
 #define FOSC 48.0  // MHz   avec Q=16Mhz
 #define BAUD 115200  // UART2
// P18F47J53_Q16MHz_48MHz_w_PLL.cfgsch
 #endif

#define Device_LCD_ADR 0x74   // LCD 2119 adresse I2C du PCF8574


#include "built_in.h"     // for  Hi  Lo ..etc
#include "../common/String_routines.h"

#define CLS 12
#define CR 13
#define LF 10
#define TAB 9
#define BACK 8
#define Separator 0x20   // space

 // *********LCD  COG 2x16  cars , CONFIGURATION sur PORTD *********
 sbit LCD_RS at LATD2_bit;
 sbit LCD_EN at LATD3_bit;
 sbit LCD_D4 at LATD4_bit;
 sbit LCD_D5 at LATD5_bit;
 sbit LCD_D6 at LATD6_bit;
 sbit LCD_D7 at LATD7_bit;

 sbit LCD_RS_Direction at TRISD2_bit;
 sbit LCD_EN_Direction at TRISD3_bit;
 sbit LCD_D4_Direction at TRISD4_bit;
 sbit LCD_D5_Direction at TRISD5_bit;
 sbit LCD_D6_Direction at TRISD6_bit;
 sbit LCD_D7_Direction at TRISD7_bit;



//  Set TEMP_RESOLUTION to the corresponding resolution of used DS18x20 sensor:
//  18S20: 9  (default setting; can be 9,10,11,or 12)
//  18B20: 12
const unsigned short TEMP_RES_B = 12;
const unsigned short TEMP_RES_S = 9;



#ifdef With_DS18B20
#define DS18B20_1 &PORTE,0
sbit DS18B20_Sensor1  at PORTE.B0;
sbit DS18B20_Sensor1_Direction at TRISE.B0;
char *text = "000.00000";
char Tp[]="000.000000";
float Tf;
unsigned char  j1, j2, j3, j4, j5, j6, j7, j8,j9 ;
unsigned char  tmp_sign;
float res;
unsigned short TEMP_RESOLUTION;
unsigned temp;
// family_code
// 0x28: DS18B20
// 0x10: DS18S20
// 0x01: DS1990
// 0xFF: NoID
char family_code;
char family_code_hex[2];
char sernum[8];
char sernum_hex[2];
int col;

#endif


unsigned char CRam1[64];
char TEXTE[128];
char *txt;
char IntValue[12];
char txt0[] = " Ready for PIC  ";
char txt1[] = "18F45K22 proto  ";
char txt2[] = "with bootloader ";
char txt3[] = "Test DS18B20 12b";
char txt4[] = "Mesure ";

unsigned int Flag_Timer0;
unsigned int Cpt0;
unsigned int Flag_Timer1;
unsigned int Cpt1;

unsigned int i,j,k,l;                              // Loop variable
unsigned int M;
unsigned int EA0, temp_res;
unsigned int Table_EA[8][8];
unsigned int Nbval;
unsigned Somme_EA[8];

unsigned long Freq;
float f1;

#ifdef With_UART1
#define MAXLEN1 128
unsigned char buffer1[MAXLEN1];
unsigned int Index1=0;
unsigned int i1=0;
unsigned int UART1_DataReady=0;
unsigned char c1=0;
unsigned char *p1;
#endif


void Interrupts() iv 0x0008 ics ICS_AUTO
{
//UART1
#ifdef With_UART1
  if((RC1IF_bit==1) && (RC1IE_bit==1))
  {
     c1 = RCREG1;
       //UART_Write('*');
     if(OERR1_bit)
      {
       CREN1_bit = 0;
       CREN1_bit = 1;
      }
     if(FERR1_bit)
     {
       c1 = RCREG1;
       //c1 = 0;
     }

     if (c1==13)
      {
      UART1_DataReady=1;
      buffer1[i1]=0;
      Index1=i1;
      i1=0;
      c1=0;
     }
     else
     {
       buffer1[i1]=c1;
        Index1=i1;
        i1++;
      }
     if (i1 >=MAXLEN1)
      {
          UART1_DataReady=2;
          RC1IE_bit=0 ;    //interdit IT Reception UART
          buffer1[i1]=0;
          Index1=i1;
          i1=0;
          c1=0;
      }
   }
   #endif

   #ifdef With_TMR0
  //   ====  IT Timer0  =============
  if((TMR0IE_bit==1) && (TMR0IF_bit==1))
  {
    #ifdef DEBUGGING
    TXREG1='*';
    #endif
    Cpt0++;
    if(Cpt0>NB_IT_TMR0)
     {
       Flag_Timer0=1;
       TMR0IE_bit=0;  // interdit interrupt
       Cpt0=0;
       TMR0ON_bit=0; // stop timer
     }
      // 1000msec at 48MHz et prescaler=256
      TMR0H= 0x48; // hi 18661;
      TMR0L =0xE5 ; // Lo 18661;
      TMR0IF_bit=0; // Raz Flag
  }
  #endif
   #ifdef With_TMR1
  //   ====  IT Timer1  =============
  if((TMR1IE_bit==1) && (TMR1IF_bit==1))
  {
      // TMR1IE_bit=0;  // interdit interrupt
      Cpt1++;
      if (Cpt1>100)
      {
          TXREG1='$';  // pour debugging sur UART1
          Cpt1=0;
      }
      Flag_Timer1=1;
      TMR1ON_bit=0; // stop timer
       // 25mS  at 48MHz  28036 => 6D84  prescaler =8
       TMR1H= 0x6D; // hi 28036;
       TMR1L =0x84 ; // Lo 28036;
      TMR1IF_bit=0; // Raz Flag
  }
  #endif
}

void Init_Timer4()
 {
  T4CON=0;
  //prescaler select=01 => 1/4
  T4CKPS1_bit=0;
  T4CKPS0_bit=1;
  // postscaleer =1/8  select=0111
  T4OUTPS3_bit=0;
  T4OUTPS2_bit=1;
  T4OUTPS1_bit=1;
  T4OUTPS0_bit=1;
  TMR4=0;
  PR4= 50 ;     // 50*8*4*4/16=> 0.4mS @ 16MHz
  TMR4IF_bit=0;     // Reset Timer1 Flag
  TMR4IE_bit=0;     //disable interrupt TMR4
  TMR4ON_bit=0;
  IPR5.TMR4IP=0;
}

void Init_Timer1(void)
{
 //  T1CON.RD16=1 ;  // Mode 16 bits
// T1RUN_bit=0 ;  //  Device clock is NOT derived from Timer1 oscillator
 T1CKPS1_bit=1;  // prescaler =1/8
 T1CKPS0_bit=1;
 T1OSCEN_bit=0; // Secondary Oscillator Disabled
 T1CON.SYNC=0;   // Synchro extern clock input with Fosc  (ignore)
 T1CON.TMR1CS1=0;  // clock source= Fosc/4
 T1CON.TMR1CS0=0;
 T1CON.TMR1ON=0;   // Stop timer1

// 25mS  at 48MHz  28036 => 6D84  prescaler =8
  TMR1H= 0x6D; // hi 28036;
  TMR1L =0x84 ; // Lo 28036;
  //----
  IPR1.TMR1IP=1;      // set hihh priority for Timer1
  RCON.IPEN = 1;      // Enable High interrupt priority model.

  TMR1IF_bit=0;      // raz flag interrupt
  INTCON.PEIE = 0;    // enable interupt Peripheriques
  T1CON.TMR1ON=0;     // desactive Timer1
  PIE1.TMR1IE=0;      // Disable Interrupt Timer1
  GIE_bit = 0;     // Desactive global interrupt
}

 #ifdef With_UART1
void UART1_Write_CText(const char *txt1)
{
   while (*txt1)
    UART1_Write(*(txt1++));
}

void CRLF1()
{
 UART1_Write(CR);
  UART1_Write(LF);
}

 void RAZ_UART1()
{
      RC1IE_bit=0 ;
      for (i1=0;i1<MAXLEN1;i1++) buffer1[i1]=0;
      i1=0;
      Index1=0;
      c1=RCREG1;
      c1=0;
      UART1_DataReady=0;
      RC1IE_bit=1 ;
}
#endif

void Init_Hardware()
{
  PMD0=0;
  C1ON_bit = 0;       // Disable comparators
  C2ON_bit = 0;
  PORTB = 0;
  TRISB=0xFF;       //  2 Input for Encoder + BP   + test mode
  ANSELB=0;

  PORTA = 0xFF;
  TRISA=0b11100111 ;   // RA3,RA4 as output  RA1,2,5=input  RA0 =Analog
  ANSELA=0x01;   // RA0 as analog

  ANSELC=0;
  PORTC = 0xFF;      // set PORTC all inoputs  RC6 will be output for UART1
  TRISC=0b11111111 ;

  ANSELE=0;
  TRISE=0;
  PORTE=0xFF;

  PORTD = 0;  // pour LCD
  TRISD=0;
  ANSELD  = 0;       // Configure AN pins as digital I/O
  HLVDCON.HLVDEN=0;
  }

void Resolution()
{
      Ow_Reset(DS18B20_1);                         // Onewire reset signal
      Ow_Write(DS18B20_1, 0x33);                   // Issue command Read_ROM
      Delay_us(120);
      family_code = Ow_Read(DS18B20_1);
      switch( family_code )
      {
       case 0x28:
       TEMP_RESOLUTION = TEMP_RES_B;
       break;
       case 0x10:
       TEMP_RESOLUTION = TEMP_RES_S;
       break;
       case 0x01:
       TEMP_RESOLUTION = 0;
       break;
       case 0xFF:
       TEMP_RESOLUTION = 0;
       break;
       default:
       TEMP_RESOLUTION = 0;
       break;
      }
 // Unique Part Serial Number
     Ow_Reset(DS18B20_1);                         // Onewire reset signal
     Ow_Write(DS18B20_1, 0x33);                   // Issue command Read_ROM
     Delay_ms(750);
     for(i = 0; i <= 7; i++)
     {
     sernum[i] = Ow_Read(DS18B20_1);
     }
}

void Read_Temperature()
{
 // Perform temperature reading
    Ow_Reset(DS18B20_1);                         // Onewire reset signal
    Ow_Write(DS18B20_1, 0xCC);                   // Issue command SKIP_ROM
    Ow_Write(DS18B20_1, 0x44);                   // Issue command CONVERT_T
    Delay_us(120);

    Ow_Reset(DS18B20_1);
    Ow_Write(DS18B20_1, 0xCC);                   // Issue command SKIP_ROM
    Ow_Write(DS18B20_1, 0xBE);                   // Issue command READ_SCRATCHPAD

    temp =  Ow_Read(DS18B20_1);
    temp = (Ow_Read(DS18B20_1) << 8) + temp;
}

void Display_SerialNumber()
{
 int i;
 int col = 17;     // en local , sinon effet de bord avec UART ???
 CRam1[0]=0;
       #ifdef With_UART1
           UART1_Write_CText("Code ID identification 64 bits = ");
       #endif
       for(i = 0; i <= 7; i++)
        {
           col = col - 2;
           ByteToHex(sernum[i], sernum_hex);
           Lcd_Out(1, col, sernum_hex);
           Delay_ms(50);
           CRam1[7-i]=sernum[i] ;
        }
       #ifdef With_UART1
            for (i=0;i<=7;i++)  
            {
            ByteToHex(CRam1[i],sernum_hex)  ;
            UART1_Write_Text(sernum_hex );
            }
            CRLF1()  ;
       #endif
}


void Display_Type()
{   
      switch( family_code )
      {
       case 0x28:
         Lcd_Out(2, 1, "18B20");
         break;
       case 0x10:
         Lcd_Out(2, 1, "18S20");
         break;
       case 0x01:
         Lcd_Out(2, 1, "DS1990");
         break;
       case 0xFF:
         Lcd_Out(2, 1, "NoID  ");
         break;
       default:
        ByteToHex(family_code, family_code_hex);
        Lcd_Out(2, 1, family_code_hex );
         break;
      }
      // c'est plus long mais moins compliquer en 2 fois
       #ifdef With_UART1
       UART1_Write_CText("Code hexa Famille : ");
       switch( family_code )
      {
       case 0x28:
       UART1_Write_CText(" 18B20: ");
        break;
       case 0x10:
       UART1_Write_CText("18S20");
       break;
       case 0x01:
       UART1_Write_CText("DS1990");
       break;
       case 0xFF:
       UART1_Write_CText( "NoID  ");
       break;
       default:
       ByteToHex(family_code, family_code_hex);
       UART1_Write_Text(family_code_hex );// ????
       break;
      }
       #endif
}

void Display_Temperature()
{
     unsigned short RES_SHIFT = TEMP_RESOLUTION - 8;
     char temp_whole;
     unsigned int temp2write;
     unsigned int temp_fraction;
     temp2write = temp;
     // Check if temperature is negative
     if (temp2write & 0x8000) 
        {
        text[0] = '-';
        temp2write = ~temp2write + 1;
        }
     // Extract temp_whole
     temp_whole = temp2write >> RES_SHIFT ;
     // Convert temp_whole to characters
     if (temp_whole/100)
         text[0] = temp_whole/100  + 48;
     else
        text[0] = ' ';
     text[1] = (temp_whole/10)%10 + 48;             // Extract tens digit
     text[2] =  temp_whole%10     + 48;             // Extract ones digit
     text[3] = ',';  // french decimale
     // Extract temp_fraction and convert it to unsigned int
     temp_fraction  = temp2write << (4-RES_SHIFT);
     temp_fraction &= 0x000F;
     temp_fraction *= 625;
     // Convert temp_fraction to characters
     text[4] =  temp_fraction/1000    + 48;         // Extract thousands digit
     text[5] = (temp_fraction/100)%10 + 48;         // Extract hundreds digit
     text[6] = (temp_fraction/10)%10  + 48;         // Extract tens digit
     text[7] =  temp_fraction%10      + 48;         // Extract ones digit
     text[8] =0;
     // Print temperature on LCD
     Lcd_Out(2, 7, text);
     // Print degree character, 'C' for Centigrades
     Lcd_Chr_CP('d');                             // 176 ASCII for degree symbol
     Lcd_Chr_CP('C');
     #ifdef With_UART1
     UART1_Write_CText("Temp = ");
     UART1_Write_Text(text);
     CRLF1();
     #endif
}

void main()
{
#ifdef OSCILLATEUR_INTERNE
  /*  // 16MHz
  OSCCON.IRCF2=1;
  OSCCON.IRCF1=1;
  OSCCON.IRCF0=1;
  */
  // 8Mhz
  OSCCON.IRCF2=1;
  OSCCON.IRCF1=1;
  OSCCON.IRCF0=1;
  OSCCON.SCS1=1;  // internal oscillator block
  OSCCON.SCS0=0;   
  #ifndef DEBUGGING
  while(OSCCON.HFIOFS==0);
  #endif
#endif
 
   Init_Hardware();
  
   txt=&TEXTE[0];

  #ifdef With_UART1
  // Initalize USART1 (19200,8,N,1)
  UART1_Init(19200);
  while (UART1_Tx_Idle() == 1) UART1_Write(13);    // vide le buffer
  UART1_Write(CLS);    // efface l'ecran
  Delay_ms(500);       // necessaire pour effacer l'ecran
  CRLF1();

  UART1_Write_CText("Mikroc Pro 6.620\r\n ");
  UART1_Write_CText("version :"Version"\r\n");
  UART1_Write_CText("Source :"Source"\r\n");
  UART1_Write_CText("18F45K22 Ready for PIC\r\n ");
  UART1_Write_CText("LCD COG2x16 mode 4 bits sur PORTD \r\n");
  UART1_Write_CText("UART1 via USB -> COM23 Vbray Terminal\r\n ");
  UART1_Write_CText("Test specifiq. capteur OWS DS18B20 \r\n\r\n");
  #ifdef TEST_FOSC
  Freq = Clock_kHz();
  UART1_Write_CText(" Fosc =");
  LongWordToStr(Freq, txt) ;
  UART1_Write_Text(txt);
  UART1_Write_CText(" KHz\r\n");
  UART1_Write_CText(" Check delay de 5000mS entre # et @\r\n");
  UART1_Write('#');  CRLF1();
  Delay_ms(5000);
  UART1_Write('@');  CRLF1();
  #endif
  UART1_Write_CText("init UART1 19200,8,N,1\r\n ");
  UART1_Write_CText("Init LCD COG 2x16 mode 4 bits \r\n ");
  #endif   //UART1

  Lcd_Init();                                    // Initialize LCD
  Lcd_Cmd(_LCD_CLEAR);                           // Clear LCD
  Lcd_Cmd(_LCD_CURSOR_OFF);                      // Turn cursor off
  
   Resolution();
   Display_SerialNumber();
   Delay_ms(1000);
   Display_Type();
  
  // Main loop
  do
  {
    Read_Temperature();
    // Format and display result on Lcd (and UART)
    Display_Temperature();
    Delay_ms(1000);
  } while (1);
}

/*
Mikroc Pro 6.620
 version :02-01-2016
Source :18F45K22_DS18B20_OneWire.c
18F45K22 Ready for PIC
 LCD COG2x16 mode 4 bits sur PORTD
UART1 via USB -> COM23 Vbray Terminal
 Test specifiq. capteur OWS DS18B20

 Fosc =      8000 KHz
 Check delay de 5000mS entre # et @
#
@
init UART1 19200,8,N,1
 Init LCD COG 2x16 mode 4 bits
 Code ID identification 64 bits = B8031564C783FF28
Code hexa Famille :  18B20: Temp =  21,3125
Temp =  21,3125
Temp =  21,1875
Temp =  21,1875
Temp =  21,1875
Temp =  21,1875
Temp =  21,3125

*/